//+------------------------------------------------------------------+
//|                                          NonLagMA_v7.1_MTF.mq4   |
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "NonLagMA_v7.1_MTF"

#property  indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_width1 3
#property indicator_color2 Lime
#property indicator_width2 3
#property indicator_color3 Yellow
#property indicator_width3 3
//-------------------------------------------------------------------------------------------------------------------------------+
extern int     Price          = 0;  //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close) 
extern int     Length         = 15;  //Period of NonLagMA
extern int     Displace       = 0;  //DispLace or Shift 
extern double  PctFilter      = 0;  //Dynamic filter in decimal
extern int     Color          = 1;  //Switch of Color mode (1-color)  
extern int     ColorBarBack   = 1;  //Bar back for color mode
extern double  Deviation      = 0;  //Up/down deviation        
extern int     AlertMode      = 0;  //Sound Alert switch (0-off,1-on) **** CONTINUOUS ALERT!WHEN "ON"
extern int     WarningMode    = 0;  //Sound Warning switch(0-off,1-on) 

extern int       LineSize1           = 3 ;
extern int       CountBars           = 600 ; 
extern bool      NoName              = true ;

extern int       TF                  = 15;    
bool             StepTimeFrame_Up    = true ;  

double Buffer1[];
double Buffer2[];
double Buffer3[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
   { IndicatorDigits(+6);
     IndicatorBuffers(2);
     SetIndexStyle (0,DRAW_LINE, STYLE_SOLID, LineSize1);
     SetIndexBuffer(0,Buffer1);
     SetIndexStyle (1,DRAW_LINE, STYLE_SOLID, LineSize1);
     SetIndexBuffer(1,Buffer2);
     SetIndexStyle (2,DRAW_LINE, STYLE_SOLID, LineSize1);
     SetIndexBuffer(2,Buffer3);
     
//===================================================================
   switch(TF)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
      SetStepTimeFrame_Up();
   }   

    
    SetIndexLabel (0, "[TF "+TF+"]["+Price+" , "+DoubleToStr(Length ,0)+" ]");
    SetIndexLabel (1, "[TF "+TF+"]["+Price+" , "+DoubleToStr(Length ,0)+" ]");
    

        string  ThisName = "MaNonLag";
        string Text=ThisName;
        Text=Text+"  (MTF "+TF;
        Text=Text+")";
        Text=Text+"(";
        Text=Text+" "+Price;
        Text=Text+" , "+DoubleToStr(Length ,0);
        Text=Text+")  ";
        IndicatorShortName(Text);
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-   
//=====================================================================            
     }
      return(0);
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+  
int deinit()
   {   SetStepTimeFrame_Up();
   }
    return(0);
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
   {  
       datetime TimeArray[];
       int counted_bars=IndicatorCounted();
       int limit;
       int i,y;
   
       if(counted_bars<0) return(-1);
       limit=Bars-counted_bars;
    // limit=Bars-counted_bars + TF/Period();//************PROBLEM
       ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TF);
     
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
       

//===================================================================================================================================================

   for(i=0,y=0; i<limit; i++)
      {
        if(Time[i]<TimeArray[y]) y++;
         {
           Buffer1[i] = iCustom(NULL, TF, "NonLagMA_v7.1", Price,Length,Displace,PctFilter,Color,ColorBarBack,Deviation,AlertMode,WarningMode, 0 , y);
           Buffer2[i] = iCustom(NULL, TF, "NonLagMA_v7.1", Price,Length,Displace,PctFilter,Color,ColorBarBack,Deviation,AlertMode,WarningMode, 1 , y);  
           Buffer3[i] = iCustom(NULL, TF, "NonLagMA_v7.1", Price,Length,Displace,PctFilter,Color,ColorBarBack,Deviation,AlertMode,WarningMode, 2 , y);                             
         }
      }

      
   return(0);
   }
//==============================step timeframe up =========+
  void SetValues(int p1)        {   TF = p1;  }                                    
  void SetStepTimeFrame_Up()    {  if (StepTimeFrame_Up)                 
      {  switch (Period()  )                
      {  case PERIOD_M1  :  SetValues(PERIOD_M5);    break;       
         case PERIOD_M5  :  SetValues(PERIOD_M15);   break;         
         case PERIOD_M15 :  SetValues(PERIOD_M30);   break;     
         case PERIOD_M30 :  SetValues(PERIOD_H1);    break;            
         case PERIOD_H1  :  SetValues(PERIOD_H4);    break;               
         case PERIOD_H4  :  SetValues(PERIOD_D1);    break;                
         case PERIOD_D1  :  SetValues(PERIOD_W1);    break;                
         case PERIOD_W1  :  SetValues(PERIOD_MN1);   break;             
         case PERIOD_MN1 :  SetValues(PERIOD_MN1);   break;                   
   } } }    
//================HORIZONTAL COLOR LINES===================+

